char *revision = "2.0"; /* tip+ revision */
#define PATCHLEVEL 0

/*
 * Copyright (c) 1983 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
 
/*
 * Modifications by Warren Tucker <wht%n4hgf.uucp@emory.mathcs.emory.edu>
 * for eight-bit transparent pass through and file transfer protocols
 * are unencumbered in any way. They are yours, ours, everybody's, nobody's.
 */
/*+:EDITS:*/
/*:05-08-1990-15:05-wht@n4hgf-rawthru */
/*:05-08-1990-15:00-wht@n4hgf-move tip.c original to tip-orig.c */


 /* Modifications by Kenar(Kenji Arisawa)
 *	--- current address is <arisawa@aichi-u.ac.jp>
 *  16-09-1993 (tip+ ver 1.00)
 *  1. Enrichment of login script.
 *  2. Japanese support.
 *
 *	9-12-1995 (tip+ ver.2.00)
 *	1. Bug fix in login.c
 *	2. tip variable xfer
 *	3. tip variable keymap
 *	4. high speed modem support
 *	5. Renewed old codes in libacu and xfer.
 */


#ifndef lint
char copyright[] =
"@(#) Copyright(c) 1983 The Regents of the University of California.\n\
 All rights reserved.\n";
#endif /* not lint */

#ifndef lint
static char sccsid[] = "@(#)tip.c 5.8 (Berkeley) 9/2/88 (mod by wht@n4hgf)";
#endif /* not lint */

/*
 * tip - UNIX link to other systems
 *  tip [-psv] [-speed] system-name [data]
 * or
 *  cu phone-number [-s speed] [-l line] [-a acu]
 */
#include <sys/ioctl.h>
#include "tip.h"

/*
 *	Baud rate mapping table
 *	- Kenar -
 */
typedef struct baudmap
{	char *name;
	int br;
	int bc;
} BAUD;
BAUD bmap[] = 
{	/* see <sys/ttydev.h> for NeXT. - Kenar - */
	"0",	0,		B0,
	"50",	50,		B50,
	"75",	75,		B75,
	"110",	110,	B110,
	"134",	134,	B134,
	"150",	150,	B150,
	"200",	200,	B200,
	"300",	300,	B300,
	"600",	600,	B600,
	"1200",	1200,	B1200,
	"2400",	2400,	B2400,
	"4800",	4800,	B4800,
	"9600",	9600,	B9600,
	"14400",	14400,	B14400,
	"19200",	19200,	B19200,
	"28800",	28800,	B28800,
	"38400",	38400,	B38400,
	"43200",	43200,	B43200,
	"57600",	57600,	B57600,
	"HUP",	0,	B0,
	"EXTA",	0,	EXTA,
	"EXTB",	0,	EXTB,
	NULL,	-1,		-1
};

/* tipx */
int rawthru = 0;
char *rawthru_msg = "\r\n--> raw tip:  3 ~ rapidly for ~ equivalent\r\n";
char *no_rawthru_msg = "\r\n--> normal tip: 1 ~ == ~\r\n";
extern char opened_tty[];

/* tip+: file handle of Host.tipp - Kenar - */
FILE *ftipp;

int page;
int disc = OTTYDISC;		/* tip normally runs this way */
sigfunc_t	intprompt();
sigfunc_t	timeout();
sigfunc_t	cleanup();
char *login();
char *sname();
char PNbuf[256];			/* This limits the size of a number */
struct sgttyb ttyarg;


/*+-------------------------------------------------------------------------
	B_to_baud_rate(code) - convert CBAUD B_ code to baud rate string
--------------------------------------------------------------------------*/
char *
B_to_baud_rate(code)
int code;
{	/* mod by Kenar */
	int n;
	for(n=0; bmap[n].name; n++)
		if(bmap[n].bc == code)
			return(bmap[n].name);
	return("-----");
}	/* end of B_to_baud_rate */


main(argc,argv)
char *argv[];
{
	int uuid;
	char *system = NOSTR;
	char *data = NOSTR;
	register int i;
	register char *p;
	char sbuf[12];

	uid = getuid();
	gid = getgid();
	euid = geteuid();	/* should be root */
	egid = getegid();
	uuid = getuucpuid();

	if(equal(sname(argv[0]),"cu"))
	{
		setreuid(uid,uuid);
		cumode = 1;
		cumain(argc,argv);
		goto cucommon;
	}

	if(argc < 2)
	{
		fprintf(stderr,"usage: tip [-psv] [-speed] [system-name] [data]\n");
		exit(1);
	}

	for(; argc > 1; argv++,argc--)
	{
		if(argv[1][0] != '-')
		{
			if(system)
				data = argv[1];
			else
				system = argv[1];
		}
		else switch(argv[1][1])
		{

		case 'p':
			page++;
			break;
		case 's':
			slip++;
			break;
		case 'v':
			vflag++;
			break;

		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			BR = atoi(&argv[1][1]);
			break;

		default:
			fprintf(stderr,"tip: %s, unknown option\n",argv[1]);
			break;
		}
	}
	if(!isatty(0) && !slip && !page)
	{
		fprintf(stderr,"tip: warning: input is not a tty\n");
	}
	if(slip)
	{
		setreuid(euid,uuid);
		uid = 0;
	}
	else 
	{
		setreuid(uid,uuid);
	}
	euid = uuid;

	if(system == NOSTR)
		goto notnumber;
	if(isalpha(*system))
		goto notnumber;
	/*
	 * System name is really a phone number...
	 * Copy the number then stomp on the original (in case the number
	 *	is private, we don't want 'ps' or 'w' to find it).
	 */
	if(strlen(system) > sizeof PNbuf - 1)
	{
		fprintf(stderr,"tip: phone number too long (max = %d bytes)\n",
		    sizeof PNbuf - 1);
		exit(1);
	}
	strncpy( PNbuf,system,sizeof PNbuf - 1 );
	for(p = system; *p; p++)
		*p = '\0';
	PN = PNbuf;
	(void)sprintf(sbuf,"tip%d",BR);
	system = sbuf;

notnumber:
	signal(SIGINT,cleanup);
	signal(SIGQUIT,cleanup);
	signal(SIGHUP,cleanup);
	signal(SIGTERM,cleanup);
	signal(SIGPIPE,cleanup);

	if((i = hunt(system)) == 0)
	{
		printf("all ports busy\n");
		exit(3);
	}
	if(i == -1)
	{
		printf("tip: link down\n");
		(void)uu_unlock(uucplock);
		exit(3);
	}
	setbuf(stdout,NULL);
	loginit();

	/*
	 * Kludge, their's no easy way to get the initialization
	 *   in the right order, so force it here
	 */
	if((PH = getenv("PHONES")) == NOSTR)
		PH = "/etc/phones";
	
	{	/* added by Kenar */
		char *TIPPDIR;
		TIPPDIR = getenv("TIPP");
		if(TIPPDIR)
		{	char buf[BUFSIZ];
			strcpy(buf,TIPPDIR);
			strcat(buf,"/");
			strcat(buf,system);
			strcat(buf,".tipp");
			printf("[Using script: %s]\r\n",buf);
			ftipp = fopen(buf,"r");
			if(ftipp) LS = makstr(buf);			
			HW = 0;
		}
		if(!ftipp && LS) ftipp = fopen(LS,"r");
	}	
	
	
	vinit();	/* init variables from ".tiprc" and ftipp */
	if(vflag) puts("vinit: done");
	setparity();
	if(vflag) puts("setparity: done");	/* set the parity table */
	if((i = speed(number(value(BAUDRATE)))) == 0)
	{
		printf("tip: bad baud rate %d\n",number(value(BAUDRATE)));
		(void)uu_unlock(uucplock);
		exit(3);
	}

	if(slip)
	{
		if(SA == NOSTR)
		{
			printf("tip: local addr not set\n");
			uu_unlock(uucplock);
			exit(3);
		}
		if(DA == NOSTR)
		{
			printf("tip: destination addr not set\n");
			uu_unlock(uucplock);
			exit(3);
		}
		if(SM == NOSTR)
		{
			printf("tip: slip netmask not set\n");
			uu_unlock(uucplock);
			exit(3);
		}
	}



	/*
	 * Now that we have the logfile and the ACU open
	 *  return to the real uid and gid.  These things will
	 *  be closed on exit.  Swap real and effective uid's
	 *  so we can get the original permissions back
	 *  for removing the uucp lock.
	 */
	user_uid();	/* in the case of slip, we are now priviliged */

	/*
	 * Hardwired connections require the
	 *  line speed set before they make any transmissions
	 *  (this is particularly true of things like a DF03-AC)
	 */

	if(HW)	ttysetup(i);
	
	if(p = lconnect())
	{
		printf("\07%s\n[EOT]\n",p);
		daemon_uid();
		(void)uu_unlock(uucplock);
		exit(1);
	}
	
	if(!HW)	ttysetup(i);
	
	setpio(); /* set pread and pwrite. (Kenar) */


	if(ftipp)
	{
		fprintf(stderr,"\07[Logging in %s]\r\n",system);
		if(p = login(ftipp))
		{	printf("\07%s\n[EOT]\n",p);
			daemon_uid();
			(void)uu_unlock(uucplock);
			exit(1);
		}
	}

	if(page)
	{
		i = sendpage(data);
		daemon_uid();
		(void)uu_unlock(uucplock);
		exit(i);
	}

	if(slip)
	{
		i = runslip();
		daemon_uid();
		(void)uu_unlock(uucplock);
		exit(i);
	}

cucommon:
	/*
	 * From here down the code is shared with
	 * the "cu" version of tip.
	 */

	ioctl(0,TIOCGETP,(char *)&defarg);
	ioctl(0,TIOCGETC,(char *)&defchars);
	ioctl(0,TIOCGLTC,(char *)&deflchars);
	ioctl(0,TIOCGETD,(char *)&odisc);
	arg = defarg;
	
	/* tipx */
	arg.sg_flags = (rawthru?RAW:CBREAK);
	/* tip: ---
	arg.sg_flags = ANYP | CBREAK;
	*/

	tchars = defchars;
	tchars.t_intrc = tchars.t_quitc = -1;
	ltchars = deflchars;
	ltchars.t_suspc = ltchars.t_dsuspc = ltchars.t_flushc
	    = ltchars.t_lnextc = -1;
	raw();

	pipe(fildes);
	pipe(repdes);
	signal(SIGALRM,timeout);

	/*
	 * Everything's set up now:
	 *	connection established (hardwired or dialup)
	 *	line conditioned (baud rate, mode, etc.)
	 *	internal data structures (variables)
	 * so, fork one process for local side and one for remote.
	 */

	/* tip+, tipx & tip message */
	printf("\r\n");
	printf("tip+ (%s)",revision);
	printf("       --- tipx(x1.21.01) mod by Kenar\r\n");
	puts("tipx (x1.21.01)   --- tip 4.3 mod by wht@n4hgf\r");
	printf("tip 4.3: ");
	puts(
	"Copyright (c) 1983 The Regents of the University of California.\r");
	printf("connected to %s\r\n",opened_tty);
	printf("line speed = %s, tandem = %s\r\n",
		B_to_baud_rate(ttyarg.sg_ospeed),
		(ttyarg.sg_flags & TANDEM) ? "yes" : "no");

	if(pid = fork())
		tipin();
	else
		tipout();
	/*NOTREACHED*/
}

sigfunc_t
cleanup()
{

	daemon_uid();
	(void)uu_unlock(uucplock);
	if(pid)
	{
		(void) kill(pid,SIGTERM);
		unraw();
	}
	else if(odisc)
		ioctl(0,TIOCSETD,(char *)&odisc);
	exit(0);
}

/*
 * Muck with user ID's.  We are setuid to the owner of the lock
 * directory when we start.  user_uid() reverses real and effective
 * ID's after startup, to run with the user's permissions.
 * daemon_uid() switches back to the privileged uid for unlocking.
 * Finally, to avoid running a shell with the wrong real uid,
 * shell_uid() sets real and effective uid's to the user's real ID.
 */
static int uidswapped;

user_uid()
{
	if(uidswapped == 0)
	{
		setregid(egid,gid);
		setreuid(euid,uid);
		uidswapped = 1;
	}
}

daemon_uid()
{
	if(uidswapped)
	{
		setreuid(uid,euid);
		setregid(gid,egid);
		uidswapped = 0;
	}
}

shell_uid()
{

	setreuid(uid,uid);
	setregid(gid,gid);
}

/*
 * put the controlling keyboard into raw mode
 */
raw()
{

	ioctl(0,TIOCSETP,&arg);
	ioctl(0,TIOCSETC,&tchars);
	ioctl(0,TIOCSLTC,&ltchars);
	ioctl(0,TIOCSETD,(char *)&disc);
}


/*
 * return keyboard to normal mode
 */
unraw()
{

	ioctl(0,TIOCSETD,(char *)&odisc);
	ioctl(0,TIOCSETP,(char *)&defarg);
	ioctl(0,TIOCSETC,(char *)&defchars);
	ioctl(0,TIOCSLTC,(char *)&deflchars);
}

static jmp_buf promptbuf;

/*
 * Print string ``s'', then read a string
 *  in from the terminal.  Handles signals & allows use of
 *  normal erase and kill characters.
 */
prompt(s,p)
char *s;
register char *p;
{
	register char *b = p;
	sigfunc_t(*oint)(),(*oquit)();

	stoprompt = 0;
	oint = signal(SIGINT,intprompt);
	oquit = signal(SIGQUIT,SIG_IGN);
	unraw();
	printf("%s",s);
	if(setjmp(promptbuf) == 0)
		while((*p = getchar()) != EOF && *p != '\n')
			p++;
	*p = '\0';

	raw();
	signal(SIGINT,oint);
	signal(SIGQUIT,oint);
	return(stoprompt || p == b);
}

/*
 * Interrupt service routine during prompting
 */
sigfunc_t
intprompt()
{

	signal(SIGINT,SIG_IGN);
	stoprompt = 1;
	printf("\r\n");
	longjmp(promptbuf,1);
}

/*
 * ****TIPIN   TIPIN****
 */
/*
 *	tipin() read stdin and send the codes to modem.
 *	- Kenar -
 */
tipin()
{
	char gch,bol = 1;
	int keymap[2];
	char buf[32];
	
	/*
	 * Kinda klugey here...
	 *   check for scripting being turned on from the .tiprc file,
	 *   but be careful about just using setscript(), as we may
	 *   send a SIGEMT before tipout has a chance to set up catching
	 *   it; so wait a second, then setscript()
	 */
	 
	 /* Kenar:
	 	Tipx func setscript() is replaced by sigEMT(SCRIPT).
		see: cmds.c
	*/
	 
	/* key mapping: added by Kenar - */
	if(equal(value(KEYMAP),"")) keymap[0] = -1;
	else {
		strcpy(buf,value(KEYMAP));
		keymap[0] = buf[0];
		keymap[1] = buf[2];
		/* NOTE: we discard ':' in buf[1] */
	}
	
	if(boolean(value(SCRIPT)))
	{
		sleep(1);
		sigEMT(SCRIPT);
	}

	while(1){
		gch = getchar();
		if(gch == keymap[0]) gch = keymap[1]; /* added by Kenar */
		
		if((gch == character(value(ESCAPE))) && bol)
		{
			if(!(gch = escape())) continue;
		}
		else if(!rawthru && !cumode &&
			gch == character(value(RAISECHAR)))
		{
			boolean(value(RAISE)) = !boolean(value(RAISE));
			continue;
		}
		else if(gch == '\r')
		{
			bol = 1;
			pwrite(&gch,1);
			
#ifdef TDELAY
			/* added by Kenar */
			if (number(value(LDELAY)) > 0)
				nap(number(value(LDELAY)));
#endif
				
			if(boolean(value(HALFDUPLEX)))
				printf("\r\n");
			continue;
		}
		else if(!rawthru && !cumode &&	gch == character(value(FORCE)))
			gch = getchar();
		bol = any(gch,value(EOL));
		if(boolean(value(RAISE)) && islower(gch))
			gch = toupper(gch);
		pwrite(&gch,1);

#ifdef TDELAY
		/* added by Kenar */
		if (number(value(CDELAY)) > 0) 
			nap(number(value(CDELAY)));
#endif
			
		if(boolean(value(HALFDUPLEX)))
			printf("%c",gch);
	}
}

/*
 * Escape handler --
 *  called on recognition of ``escapec'' at the beginning of a line
 */
escape()
{
	register char gch;
	register esctable_t *p;
	char c = character(value(ESCAPE));
	extern esctable_t etable[];

	gch = (getchar()&0177);
	for(p = etable; p->e_char; p++)
		if(p->e_char == gch)
		{
			if((p->e_flags&PRIV) && uid)
				continue;
			(*p->e_func)(gch);
			return(0);
		}
	/* ESCAPE ESCAPE forces ESCAPE */
	if(c != gch)
		pwrite(&c,1);
	return(gch);
}

/* speed: converts baud rate to baud code */
speed(n)
int n;
{	/* Replaced by Kenar */
	int k;
	for(k = 0; bmap[k].br != -1; k++)
		if(bmap[k].br == n) return bmap[k].bc;
	return(0);
}

any(c,p)
register char c,*p;
{
	while(p && *p)
		if(*p++ == c)
			return(1);
	return(0);
}

size(s)
register char *s;
{
	register int i = 0;

	while(s && *s++)
		i++;
	return(i);
}

char *
interp(s)
register char *s;
{
	static char buf[256];
	register char *p = buf,c,*q;

	while(c = *s++)
	{
		for(q = "\nn\rr\tt\ff\033E\bb"; *q; q++)
			if(*q++ == c)
			{
				*p++ = '\\';
				*p++ = *q;
				goto next;
			}
		if(c < 040)
		{
			*p++ = '^';
			*p++ = c + 'A'-1;
		}
		else if(c == 0177)
		{
			*p++ = '^';
			*p++ = '?';
		}
		else
			*p++ = c;
next:
		;
	}
	*p = '\0';
	return(buf);
}

char *
ctrl(c)
char c;
{
	static char s[3];

	if(c < 040 || c == 0177)
	{
		s[0] = '^';
		s[1] = c == 0177 ? '?' : c+'A'-1;
		s[2] = '\0';
	}
	else 
	{
		s[0] = c;
		s[1] = '\0';
	}
	return(s);
}

/*
 * Help command
 */
help(c)
char c;
{
	register esctable_t *p;
	extern esctable_t etable[];

	for(p = etable; p->e_char; p++)
	{
		if((p->e_flags&PRIV) && uid)
			continue;
		printf("%2s",ctrl(character(value(ESCAPE))));
		printf("%-2s %c   %s\r\n",ctrl(p->e_char),
		    p->e_flags&EXP ? '*': ' ',p->e_help);
	}
}

/*
 * Set up the "remote" tty's state
 */
ttysetup(speed)
int speed; /* speed is given by baud code - Kenar - */
{
	unsigned bits = LDECCTQ;

	ttyarg.sg_ispeed = ttyarg.sg_ospeed = speed;
	ttyarg.sg_flags = RAW;
	if(boolean(value(TAND)))
		ttyarg.sg_flags |= TANDEM;
	if(boolean(value(DTRHUP)))
	{
		ioctl(FD,TIOCSDTR,0);
		ioctl(FD,TIOCHPCL,0);
	}
	ioctl(FD,TIOCSETP,(char *)&ttyarg);
	ioctl(FD,TIOCLBIS,(char *)&bits);
}

/*
 * Return "simple" name from a file name,
 * strip leading directories.
 */
char *
sname(s)
register char *s;
{
	register char *p = s;

	while(*s)
		if(*s++ == '/')
			p = s;
	return(p);
}


/* The uid could be determined by stat()-ing ACULOG */
getuucpuid()
{
	struct passwd *pw;

	if((pw = getpwnam("uucp")) == NULL)
	{
		fprintf(stderr,"tip: unable to get uucp uid\n");
		exit(1);
	}
	return(pw->pw_uid);
}
